﻿using System;
using System.Collections.Generic;
using System.Linq;
using HeuristicLab.Common;
using HeuristicLab.SimulationCore;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Simulation {
    partial class Activity1 {
        private void ProcessAction4(Model1 model, Action4 lastAction) {
            EnqueueAction1(model.CurrentTime + 1, new Action1());
        }
    }

    partial class Activity2 {
        private void ProcessAction1(Model1 model, Action1 lastAction) {
            if (model.CurrentTime < 10) EnqueueAction2(model.CurrentTime + 1, new Action2());
            else EnqueueAction3(model.CurrentTime + 1, new Action3());
        }
    }

    partial class Activity3 {
        private void ProcessAction1(Model1 model, Action1 lastAction) {
            EnqueueAction4(model.CurrentTime + 1, new Action4());
        }

        private void ProcessAction2(Model1 model, Action2 lastAction) {
            EnqueueAction4(model.CurrentTime + 1, new Action4());
        }
    }

    partial class Action1 {
        public override void Execute(Model1 model) {

        }
    }

    partial class Action2 {
        public override void Execute(Model1 model) {

        }
    }

    partial class Action3 {
        public override void Execute(Model1 model) {

        }
    }

    partial class Action4 {
        public override void Execute(Model1 model) {

        }
    }
}